# License

## Main Source 
(contents of [app/](https://github.com/samaaron/sonic-pi/tree/master/app) and [etc/synthdefs/](https://github.com/samaaron/sonic-pi/tree/master/etc/synthdefs) directories)

The MIT License (MIT)

Copyright (c) 2013, 2014, 2015 Samuel Aaron ([http://sam.aaron.name](http://sam.aaron.name))

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.


## Docs, Tutorial and Examples 
(contents of [etc/doc/](https://github.com/samaaron/sonic-pi/tree/master/etc/doc) and [etc/examples](https://github.com/samaaron/sonic-pi/tree/master/etc/examples) directories)

All the examples (in
[etc/examples](https://github.com/samaaron/sonic-pi/tree/master/etc/examples))
and contents of the doc directory including the articles and the
tutorial are copyright by Sam Aaron unless a specific author is stated
with the comment `# coded by ...` in which case the copyright is
associated with that author (2015) and the content is released under the
CC BY-NC-SA 4.0 license:

[http://creativecommons.org/licenses/by-nc-sa/4.0/](http://creativecommons.org/licenses/by-nc-sa/4.0/)


## Samples
(contents of [etc/samples/](https://github.com/samaaron/sonic-pi/tree/master/etc/samples))

All the bundled samples are individually licensed under CC0 1.0
Universal Public Domain Dedication. They have all been obtained from
[freesound.org](http://freesound.org) and links to their sources can be
found in the file [etc/samples/README.md](https://github.com/samaaron/sonic-pi/blob/master/etc/samples/README.md)

[http://creativecommons.org/publicdomain/zero/1.0/](http://creativecommons.org/publicdomain/zero/1.0/)


## Bundled Software

The following is a list of the software included in Sonic Pi with their
relevant licenses:

### Unlinked software

* [Ruby](http://ruby-lang.org) - [Ruby License](https://www.ruby-lang.org/en/about/license.txt)
* [SuperCollider](http://supercollider.sourceforge.net) - [GNU General Public License v3](http://www.gnu.org/copyleft/gpl.html)

### Dynamically Linked Libraries for GUI

* [Qt](http://qt-project.org) - [LGPL v2.1](https://www.gnu.org/licenses/lgpl-2.1.html)
* [QScintilla2](http://www.riverbankcomputing.com/software/qscintilla/intro) - [GPL v2](https://tldrlegal.com/license/gnu-general-public-license-v2)

### Included Ruby Libraries for Server
(contents of [app/server/vendor/](https://github.com/samaaron/sonic-pi/tree/master/app/server/vendor))

* [ActiveSupport](https://github.com/rails/rails/tree/master/activesupport) - [MIT License](http://opensource.org/licenses/MIT)
* [Atomic](http://github.com/headius/ruby-atomic) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [Blankslate](https://github.com/masover/blankslate) - [MIT License](http://opensource.org/licenses/MIT)
* [Did You Mean](https://github.com/yuki24/did_you_mean) - [MIT License](http://opensource.org/licenses/MIT)
* [FFI](https://github.com/ffi/ffi) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [FFI Core MIDI](https://github.com/arirusso/ffi-coremidi) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [Hamster](https://github.com/hamstergem/hamster) - [MIT License](http://opensource.org/licenses/MIT)
* [i81n](https://github.com/svenfuchs/i18n) - [MIT License](http://opensource.org/licenses/MIT)
* [Interception](https://github.com/ConradIrwin/interception) - [MIT License](http://opensource.org/licenses/MIT)
* [Kramdown](http://kramdown.gettalong.org) - [MIT License](http://opensource.org/licenses/MIT)
* [MIDI Winmm](https://github.com/arirusso/midi-winmm) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [MIDILib](https://github.com/jimm/midilib) - [Ruby License](https://www.ruby-lang.org/en/about/license.txt)
* [Multi JSON](https://github.com/intridea/multi_json) - [MIT License](http://opensource.org/licenses/MIT)
* [OSC Ruby](https://github.com/aberant/osc-ruby) - [MIT License](http://opensource.org/licenses/MIT)
* [Parslet](http://kschiess.github.io/parslet/) - [MIT License](http://opensource.org/licenses/MIT)
* [Rouge](https://github.com/jneen/rouge) - [MIT License](http://opensource.org/licenses/MIT)
* [Rubame](https://github.com/saward/Rubame) - [MIT License](http://opensource.org/licenses/MIT)
* [Ruby Beautify](https://github.com/erniebrodeur/ruby-beautify) - [MIT License](http://opensource.org/licenses/MIT)
* [Ruby Prof](https://github.com/ruby-prof/ruby-prof) - [BSD 2-Clause License](http://opensource.org/licenses/BSD-2-Clause) - [MIT License](http://opensource.org/licenses/MIT)
* [Rugged](https://github.com/libgit2/rugged) - [MIT License](http://opensource.org/licenses/MIT)
* [Thread Safe](https://github.com/ruby-concurrency/thread_safe) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [UniMIDI](https://github.com/arirusso/unimidi) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [Websocket](https://github.com/imanel/websocket-ruby) - [MIT License](http://opensource.org/licenses/MIT)
* [NArray](https://github.com/masa16/narray) - [Ruby License](https://www.ruby-lang.org/en/about/license.txt)
* [Ruby CoreAudio](https://github.com/nagachika/ruby-coreaudio) - [MIT License](http://opensource.org/licenses/MIT)
