# Live-Loops

Ok, dieses Kapitel des Tutorials ist ein Juwel. Wenn Du nur einen 
Abschnitt lesen würdest, sollte es dieser sein. `live_loop` ist ein 
einfacher Weg, genau das zu tun was, Du im letzten Abschnitt gelernt 
hast, nur ohne so viel schreiben zu müssen. Falls Du den letzten 
Abschnitt nicht gelesen hast: `live_loop` ist der beste Weg, mit Sonic 
Pi zu jammen.

Also los. Schreibe folgendes in einen neuen Workspace:

```
live_loop :foo do
  play 60
  sleep 1
end
```

Jetzt klicke den `Ausführen`-Button. Du hörst jede Sekunde ein einfaches
Piepen. Kein besonderer Spaß. Drücke aber noch nicht den `Stopp`-Button.
Ändere die `60` in `65` und drücke wieder `Ausführen`.

Whoa! Es hat sich *automatisch* verändert, ohne einen Takt auszulassen. 
Das ist Live Coding. Warum es jetzt nicht ein wenig bassiger machen? 
Verändere Deinen Code, während er abläuft:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8
  sleep 8
end
```

Dann drücke `Ausführen`.

Lass uns den Cutoff ein wenig bewegen:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Drücke wieder `Ausführen`.

Füge ein Schlagzeug hinzu:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Ändere den Ton von `e1` nach `c1`:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :c1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Und jetzt hör auf, mir zuzuhören, und spiele selbst herum. Viel Spaß!
