10.1 Tastaturkürzel

# Tastaturkürzel

Sonic Pi ist zu gleichen Teilen Musikinstrument und 
Programmierumgebung. Tastaturkürzel helfen Dir dabei, Sonic Pi viel 
*effizienter und natürlicher* zu spielen - insbesondere wenn Du live 
vor Publikum spielst. 

Ein großer Teil von Sonic Pi kann mit der Tastatur gesteuert werden. Je 
vertrauter Du mit Sonic Pi wirst, umso mehr wirst Du die Tastaturkürzel 
verwenden. *Ich selbst tippe blind, ohne die Tastatur anzussehen* 
(überlege Dir, das auch zu lernen) und bin jedesmal frustriert, wenn 
ich zur Maus greifen muss, weil mich das langsam macht. Deshalb 
verwende ich alle diese Tastaturkürzel regelmäßig. 

Wer die Tastaturkürzel beherrscht, kann auch seine Tastatur viel
effektiver benutzen. So wirst Du in kurzer Zeit programmieren wie ein 
Profi.

*Versuche aber nicht, alle auf einmal zu lernen*, merke Dir erst einmal 
die, die Du am häufigsten nutzt und erweitere dann nach und nach Dein 
Repertoire.

## Konsistenz auf verschiedenen Plattformen

Stell Dir vor Du lernst Klarinette. Du kannst davon ausgehen, dass alle 
Klarinetten aller Marken gleiche Mechaniken und Fingersätze haben. 
Hätten sie das nicht, könntest Du nicht ohne weiteres zwischen 
verschiedenen Klarinetten hin- und herwechseln. Sondern müsstest immer 
bei einer Marke bleiben.

Unglücklicherweise haben die drei wesentlichen Betriebssysteme (Linux, 
Mac OS X und Windows) alle ihre eigenen Standards für Aktionen wie 
beispielsweise Kopieren, Ausschneiden und Einfügen. Sonic Pi nutzt 
diese Standards wo immer möglich. Jedoch *liegt die Priorität auf 
plattformübergreifende Konsistenz* innerhalb von Sonic Pi, nicht auf 
dem Versuch, die Standards der jeweiligen Plattform vollumfänglich zu 
erfüllen. Das bedeutet, dass die in Sonic Pi auf dem Raspberry Pi 
gelernten Tastaturkürzel ebenso auf einem Mac oder PC mit Sonic Pi
funktionieren.

## Control und Meta

Ein Teil der Herstellung dieser Konsistenz ist die Benennung von 
Tastaturkürzeln. In Sonic Pi verwenden wir die Namen *Control* und 
*Meta* für die beiden wichtigsten Kombinationstasten. *Control* 
(*Ctrl* oder *Strg* für "Steuerung" auf deutschen Tastaturen) ist auf 
allen Plattformen gleich. Auf Linux und Windows ist *Meta* die 
*Alt*-Taste, während *Meta* auf dem Mac die *Command*-Taste ist. Um 
konsistent zu bleiben, nutzen wir den Begriff *Meta* - den Du mental 
der passenden Taste Deines Betriebssystems zuordnen musst.

## Abkürzungen

Um die Dinge einfach und lesbar zu halten, werden wir die Abkürzungen 
*C-* für *Control* und eine weitere Taste sowie *M-* für *Meta* und 
eine weitere Taste verwenden.

Wenn ein Tastaturkürzel beispielsweise erfordert, dass Du *Meta* und 
*r* gleichzeitig drückst, werden wir die Abkürzung `M-r` verwenden. Der 
Bindestrich in der Mitte (*-*) bedeutet nur "zur gleichen Zeit".

Hier sind ein paar der Tastaturkürzel, die ich am nützlichsten finde.

## Stoppen und starten

Statt immer zur Maus zu greifenm um Deinen Code auszuführen kannst Du 
einfach `M-r` drücken. Um die Musik zu stoppen, drücke `M-s`.

## Navigation

Ohne die Tastenkürzel zur Navigation bin ich verloren. Deshalb empfehle 
ich Dir dringend, diese Kürzel zu lernen. Sie funktionieren besonders
gut, wenn Du schon gelernt hast, blind zu schreiben, da sie normale
Buchstaben verwenden - so musst Du Deine Hand nicht zur Maus oder
zu den Pfeiltasten bewegen.

Mit `C-a` springst Du an den Anfang, mit `C-e` ans Ende einer Zeile. 
Eine Zeile nach oben geht es mit `C-p`, eine nach unten mit `C-n`, ein 
Zeichen vorwärts mit `C-f` und eines nach hinten mit `C-b`.

Du kannst auch alle Zeichen von der akutellen Cursorposition bis zum 
Ende der Zeile mit `C-k` löschen.

## Code Aufräumen

Um Deinen Code sauber einzurücken, drücke `M-m`.

## Hilfesystem

Zum Hilfesystem kommst Du mit `M-i`. Noch hilfreicher ist 
allerdings `C-i`, womit das Wort, auf dem der Cursor momentan steht in 
der Dokumentation nachgeschlagen wird und die Ergebnisse angezeigt 
werden. Sofortige Hilfe!

Eine Liste aller Tastaturkürzel ist in Kapitel 10.2 Cheatsheet für 
Tastenkürzel enthalten.
